/**************************************************************************/
/* LabWindows/CVI User Interface Resource (UIR) Include File              */
/* Copyright (c) National Instruments 2005. All Rights Reserved.          */
/*                                                                        */
/* WARNING: Do not add to, delete from, or otherwise modify the contents  */
/*          of this include file.                                         */
/**************************************************************************/

#include <userint.h>

#ifdef __cplusplus
    extern "C" {
#endif

     /* Panels and Controls: */

#define  ApID                            1       /* callback function: GenericPanel */
#define  ApID_Total                      2
#define  ApID_Illegal                    3
#define  ApID_SequenceError              4
#define  ApID_BadChecksum                5
#define  ApID_Other                      6
#define  ApID_211                        7
#define  ApID_214                        8
#define  ApID_213                        9
#define  ApID_215                        10
#define  ApID_212                        11
#define  ApID_210                        12
#define  ApID_PLASTIC                    13
#define  ApID_Spacecraft                 14
#define  ApID_270                        15
#define  ApID_223                        16
#define  ApID_241                        17
#define  ApID_SIT                        18
#define  ApID_SEPT                       19
#define  ApID_HET                        20
#define  ApID_LET                        21
#define  ApID_240                        22
#define  ApID_222                        23
#define  ApID_221                        24
#define  ApID_220                        25
#define  ApID_209                        26
#define  ApID_208                        27
#define  ApID_SITE                       28
#define  ApID_201                        29
#define  ApID_SEPTE                      30
#define  ApID_203                        31
#define  ApID_HETE                       32
#define  ApID_241E                       33
#define  ApID_LETE                       34
#define  ApID_202                        35
#define  ApID_240E                       36
#define  ApID_222E                       37
#define  ApID_220E                       38
#define  ApID_214E                       39
#define  ApID_212E                       40
#define  ApID_210E                       41
#define  ApID_203E                       42
#define  ApID_208E                       43
#define  ApID_202E                       44
#define  ApID_270E                       45
#define  ApID_223E                       46
#define  ApID_221E                       47
#define  ApID_215E                       48
#define  ApID_213E                       49
#define  ApID_211E                       50
#define  ApID_209E                       51
#define  ApID_201E                       52
#define  ApID_200E                       53
#define  ApID_200                        54

#define  BURSTCRIT                       2       /* callback function: GenericPanel */
#define  BURSTCRIT_GRAPH                 2
#define  BURSTCRIT_HFR2                  3
#define  BURSTCRIT_HFR1                  4
#define  BURSTCRIT_PLASMA                5
#define  BURSTCRIT_NTDS                  6
#define  BURSTCRIT_PLASTIC               7
#define  BURSTCRIT_MAG                   8
#define  BURSTCRIT_STE                   9
#define  BURSTCRIT_SWEA                  10

#define  DECOM                           3       /* callback function: Panel */
#define  DECOM_SelectFile                2       /* callback function: SelectFile */
#define  DECOM_PlotMAG                   3       /* callback function: PlotMAG */
#define  DECOM_PlotBurstCriteria         4       /* callback function: PlotBurstCriteria */
#define  DECOM_STEFit                    5       /* callback function: STEFit */
#define  DECOM_AccSTESpec                6       /* callback function: AccSTESpec */
#define  DECOM_PlotSWEARates             7       /* callback function: PlotSWEARates */
#define  DECOM_PlotSTERates              8       /* callback function: PlotSTERates */
#define  DECOM_PlotSEPHKP                9       /* callback function: PlotSEPHKP */
#define  DECOM_PlotHKP                   10      /* callback function: PlotHKP */
#define  DECOM_PlotBurst                 11      /* callback function: PlotBurst */
#define  DECOM_DisplayHKP                12      /* callback function: DisplayHKP */
#define  DECOM_DisplayPackets            13      /* callback function: DisplayPackets */
#define  DECOM_ScanBurst                 14      /* callback function: ScanBurst */
#define  DECOM_ScanHKP                   15      /* callback function: ScanHKP */
#define  DECOM_ScanApIDs                 16      /* callback function: ScanApIDs */
#define  DECOM_ByteSwap                  17
#define  DECOM_PlotPkt                   18      /* callback function: PlotPkt */
#define  DECOM_PlotSWEAFHKP              19      /* callback function: PlotSWEAFHKP */
#define  DECOM_PlotMagPacket             20      /* callback function: PlotMagPacket */
#define  DECOM_DisplayTiming             21      /* callback function: DisplayTiming */
#define  DECOM_UTCStart                  22
#define  DECOM_UTCEnd                    23
#define  DECOM_FullRange                 24
#define  DECOM_FileName                  25

#define  HKP                             4       /* callback function: GenericPanel */
#define  HKP_Sum                         2
#define  HKP_PacketNum                   3       /* callback function: PacketNum */
#define  HKP_Time                        4
#define  HKP_BACK                        5       /* callback function: BackHKP */
#define  HKP_FindNext                    6       /* callback function: FindNextHKP */
#define  HKP_SampleTime                  7
#define  HKP_NEXT                        8       /* callback function: NextHKP */
#define  HKP_TimeJitter                  9
#define  HKP_PollTimeAvg                 10
#define  HKP_PollTimeMax                 11
#define  HKP_CommandSeq                  12
#define  HKP_CommandApID                 13
#define  HKP_FindSelect                  14
#define  HKP_CommandCount                15
#define  HKP_ErrorData                   16
#define  HKP_ErrorCode                   17
#define  HKP_ErrorCount                  18

#define  MAG                             5       /* callback function: GenericPanel */
#define  MAG_GRAPH                       2
#define  MAG_SaveMag                     3       /* callback function: SaveMag */
#define  MAG_Print                       4       /* callback function: Print */
#define  MAG_MAGIFCFit                   5       /* callback function: MAGIFCFit */
#define  MAG_PacketNum                   6       /* callback function: PacketNum */
#define  MAG_ACDC                        7
#define  MAG_TEXTMSG                     8
#define  MAG_TEXTMSG_2                   9
#define  MAG_TEXTMSG_3                   10

#define  MAGIFC                          6       /* callback function: GenericPanel */
#define  MAGIFC_GRAPH                    2
#define  MAGIFC_Print                    3       /* callback function: Print */
#define  MAGIFC_PacketNum                4       /* callback function: PacketNum */
#define  MAGIFC_RateZ                    5
#define  MAGIFC_RateY                    6
#define  MAGIFC_RateX                    7
#define  MAGIFC_TimeZ                    8
#define  MAGIFC_TimeY                    9
#define  MAGIFC_TimeX                    10
#define  MAGIFC_DeltaZ                   11
#define  MAGIFC_DeltaY                   12
#define  MAGIFC_DeltaX                   13
#define  MAGIFC_OffsetZ                  14
#define  MAGIFC_OffsetY                  15
#define  MAGIFC_R2Z                      16
#define  MAGIFC_R2Y                      17
#define  MAGIFC_R2X                      18
#define  MAGIFC_A2Z                      19
#define  MAGIFC_A2Y                      20
#define  MAGIFC_A2X                      21
#define  MAGIFC_OffsetX                  22
#define  MAGIFC_MsgZ                     23
#define  MAGIFC_MsgY                     24
#define  MAGIFC_UTCZ                     25
#define  MAGIFC_UTCY                     26
#define  MAGIFC_UTCX                     27
#define  MAGIFC_MsgX                     28
#define  MAGIFC_TEXTMSG_4                29
#define  MAGIFC_TEXTMSG_5                30
#define  MAGIFC_TEXTMSG_6                31

#define  PACKET                          7       /* callback function: GenericPanel */
#define  PACKET_Sum                      2
#define  PACKET_PacketNum                3       /* callback function: PacketNum */
#define  PACKET_ApID                     4
#define  PACKET_BACK                     5       /* callback function: BackPacket */
#define  PACKET_FindNext                 6       /* callback function: FindNext */
#define  PACKET_NEXT                     7       /* callback function: NextPacket */
#define  PACKET_GRHeader                 8
#define  PACKET_Time                     9
#define  PACKET_CCSDSHeader              10
#define  PACKET_Data                     11
#define  PACKET_FindSelect               12

#define  PLOTBURST                       8       /* callback function: GenericPanel */
#define  PLOTBURST_GRAPH                 2       /* callback function: PlotBurstActive */
#define  PLOTBURST_Print                 3       /* callback function: Print */
#define  PLOTBURST_TEXTMSG               4
#define  PLOTBURST_TEXTMSG_2             5
#define  PLOTBURST_TEXTMSG_3             6
#define  PLOTBURST_TEXTMSG_4             7
#define  PLOTBURST_CURSOR                8

#define  PLOTHKP                         9       /* callback function: GenericPanel */
#define  PLOTHKP_Select9                 2
#define  PLOTHKP_Print                   3       /* callback function: Print */
#define  PLOTHKP_SaveHKP                 4       /* callback function: SaveHKP */
#define  PLOTHKP_PlotHKP                 5       /* callback function: PlotHKP */
#define  PLOTHKP_Select8                 6
#define  PLOTHKP_Select7                 7
#define  PLOTHKP_Select6                 8
#define  PLOTHKP_Select5                 9
#define  PLOTHKP_Select4                 10
#define  PLOTHKP_Select3                 11
#define  PLOTHKP_Select2                 12
#define  PLOTHKP_Select1                 13
#define  PLOTHKP_Select0                 14
#define  PLOTHKP_GRAPH                   15
#define  PLOTHKP_MAX                     16
#define  PLOTHKP_MIN                     17
#define  PLOTHKP_Log                     18
#define  PLOTHKP_AutoScale               19
#define  PLOTHKP_MaxFileSize             20
#define  PLOTHKP_MaxTimeRes              21

#define  PLOTMAG                         10      /* callback function: GenericPanel */
#define  PLOTMAG_Print                   2       /* callback function: Print */
#define  PLOTMAG_PlotMAG                 3       /* callback function: PlotMAG */
#define  PLOTMAG_GRAPH                   4
#define  PLOTMAG_MAX                     5
#define  PLOTMAG_MIN                     6
#define  PLOTMAG_AutoScale               7
#define  PLOTMAG_BurstSelect             8

#define  PLOTPKT                         11      /* callback function: GenericPanel */
#define  PLOTPKT_Print                   2       /* callback function: Print */
#define  PLOTPKT_PlotPkt                 3       /* callback function: PlotPkt */
#define  PLOTPKT_GRAPH                   4
#define  PLOTPKT_Select9                 5
#define  PLOTPKT_Select8                 6
#define  PLOTPKT_Select7                 7
#define  PLOTPKT_Select6                 8
#define  PLOTPKT_Select5                 9
#define  PLOTPKT_Select4                 10
#define  PLOTPKT_Select3                 11
#define  PLOTPKT_Select2                 12
#define  PLOTPKT_Select1                 13
#define  PLOTPKT_Select9R                14
#define  PLOTPKT_Select8R                15
#define  PLOTPKT_Select7R                16
#define  PLOTPKT_Select6R                17
#define  PLOTPKT_Select5R                18
#define  PLOTPKT_Select4R                19
#define  PLOTPKT_Select3R                20
#define  PLOTPKT_Select2R                21
#define  PLOTPKT_Select1R                22
#define  PLOTPKT_Select0R                23
#define  PLOTPKT_Select0                 24
#define  PLOTPKT_MAX                     25
#define  PLOTPKT_MIN                     26
#define  PLOTPKT_AutoScale               27
#define  PLOTPKT_Timebase                28
#define  PLOTPKT_ApID                    29
#define  PLOTPKT_Range                   30

#define  PLOTSEPHKP                      12      /* callback function: GenericPanel */
#define  PLOTSEPHKP_Select9              2
#define  PLOTSEPHKP_Print                3       /* callback function: Print */
#define  PLOTSEPHKP_SaveHKP              4       /* callback function: SaveHKP */
#define  PLOTSEPHKP_PlotSEPHKP           5       /* callback function: PlotSEPHKP */
#define  PLOTSEPHKP_Select8              6
#define  PLOTSEPHKP_Select7              7
#define  PLOTSEPHKP_Select6              8
#define  PLOTSEPHKP_Select5              9
#define  PLOTSEPHKP_Select4              10
#define  PLOTSEPHKP_Select3              11
#define  PLOTSEPHKP_Select2              12
#define  PLOTSEPHKP_Select1              13
#define  PLOTSEPHKP_Select0              14
#define  PLOTSEPHKP_GRAPH                15
#define  PLOTSEPHKP_MAX                  16
#define  PLOTSEPHKP_MIN                  17
#define  PLOTSEPHKP_AutoScale            18

#define  SCANBURST                       13      /* callback function: GenericPanel */
#define  SCANBURST_Total                 2
#define  SCANBURST_211                   3
#define  SCANBURST_221                   4
#define  SCANBURST_209                   5
#define  SCANBURST_223                   6
#define  SCANBURST_Other                 7
#define  SCANBURST_Text                  8
#define  SCANBURST_Select                9       /* callback function: ScanBurstSelect */

#define  SCANHKP                         14      /* callback function: GenericPanel */
#define  SCANHKP_ITimeJitterSat          2
#define  SCANHKP_HWVersion               3
#define  SCANHKP_HWVError                4
#define  SCANHKP_SWVersion               5
#define  SCANHKP_SWVError                6
#define  SCANHKP_ChecksumError           7
#define  SCANHKP_SizeError               8
#define  SCANHKP_SequenceError           9
#define  SCANHKP_DTAvg                   10
#define  SCANHKP_DTMax                   11
#define  SCANHKP_DTMin                   12
#define  SCANHKP_DUTCAvg                 13
#define  SCANHKP_DUTCMax                 14
#define  SCANHKP_DUTCMin                 15
#define  SCANHKP_SampleTimeEnd           16
#define  SCANHKP_SampleTimeStart         17
#define  SCANHKP_HKP                     18
#define  SCANHKP_Packets                 19
#define  SCANHKP_IErrorCount             20
#define  SCANHKP_PCommandCount           21
#define  SCANHKP_ICommandCount           22
#define  SCANHKP_IDError                 23
#define  SCANHKP_UTCEnd                  24
#define  SCANHKP_UTCStart                25
#define  SCANHKP_ITimeJitter             26
#define  SCANHKP_IPollTimeAvg            27
#define  SCANHKP_IPollTimeMax            28
#define  SCANHKP_TEXTMSG                 29
#define  SCANHKP_DeltaUTC                30
#define  SCANHKP_Delta                   31

#define  STEFIT                          15      /* callback function: GenericPanel */
#define  STEFIT_Hide                     2       /* callback function: HideSTEFit */
#define  STEFIT_FWHM0                    3
#define  STEFIT_Amplitude3               4
#define  STEFIT_Amplitude2               5
#define  STEFIT_Amplitude1               6
#define  STEFIT_Amplitude0               7
#define  STEFIT_Baseline2                8
#define  STEFIT_Baseline1                9
#define  STEFIT_QUAD                     10
#define  STEFIT_ChiSquared               11
#define  STEFIT_Select                   12
#define  STEFIT_OFFSET                   13
#define  STEFIT_GAIN                     14
#define  STEFIT_Baseline0                15
#define  STEFIT_Msg                      16
#define  STEFIT_Detector                 17
#define  STEFIT_DoorLUT                  18
#define  STEFIT_FitCurvature             19
#define  STEFIT_TEXTMSG                  20
#define  STEFIT_TEXTMSG_2                21
#define  STEFIT_TEXTMSG_3                22
#define  STEFIT_TEXTMSG_4                23
#define  STEFIT_TEXTMSG_5                24
#define  STEFIT_TEXTMSG_6                25
#define  STEFIT_TEXTMSG_7                26
#define  STEFIT_TEXTMSG_8                27
#define  STEFIT_TEXTMSG_9                28
#define  STEFIT_TEXTMSG_10               29

#define  STEFITP                         16      /* callback function: GenericPanel */
#define  STEFITP_Hide                    2       /* callback function: HideSTEFit */
#define  STEFITP_Print                   3       /* callback function: Print */
#define  STEFITP_ChiSquared              4
#define  STEFITP_Select                  5
#define  STEFITP_Msg                     6
#define  STEFITP_Detector                7
#define  STEFITP_FWHM                    8
#define  STEFITP_A7                      9
#define  STEFITP_A6                      10
#define  STEFITP_E2                      11
#define  STEFITP_A5                      12
#define  STEFITP_A4                      13
#define  STEFITP_A3                      14
#define  STEFITP_E0                      15
#define  STEFITP_A2                      16
#define  STEFITP_T                       17
#define  STEFITP_E1                      18
#define  STEFITP_A1                      19
#define  STEFITP_FitCurvature            20
#define  STEFITP_TEXTMSG_3               21
#define  STEFITP_TEXTMSG_5               22
#define  STEFITP_TEXTMSG_6               23
#define  STEFITP_TEXTMSG_8               24
#define  STEFITP_TEXTMSG_10              25

#define  STERATES                        17      /* callback function: GenericPanel */
#define  STERATES_GRAPH                  2
#define  STERATES_Print                  3       /* callback function: Print */
#define  STERATES_PlotSTERates           4       /* callback function: PlotSTERates */
#define  STERATES_MAX                    5
#define  STERATES_MIN                    6
#define  STERATES_Log                    7
#define  STERATES_RST7                   8
#define  STERATES_ULD7                   9
#define  STERATES_LLD7                   10
#define  STERATES_RST6                   11
#define  STERATES_ULD6                   12
#define  STERATES_LLD6                   13
#define  STERATES_RST5                   14
#define  STERATES_ULD5                   15
#define  STERATES_LLD5                   16
#define  STERATES_RST4                   17
#define  STERATES_ULD4                   18
#define  STERATES_LLD4                   19
#define  STERATES_RST3                   20
#define  STERATES_ULD3                   21
#define  STERATES_LLD3                   22
#define  STERATES_RST2                   23
#define  STERATES_ULD2                   24
#define  STERATES_LLD2                   25
#define  STERATES_RST1                   26
#define  STERATES_ULD1                   27
#define  STERATES_LLD0                   28
#define  STERATES_LLD1                   29
#define  STERATES_RST0                   30
#define  STERATES_ULD0                   31
#define  STERATES_AutoScale              32
#define  STERATES_TEXTMSG                33
#define  STERATES_TEXTMSG_2              34

#define  STESPEC                         18      /* callback function: GenericPanel */
#define  STESPEC_GRAPH                   2
#define  STESPEC_STEFitP                 3       /* callback function: STEFitP */
#define  STESPEC_STEFit                  4       /* callback function: STEFit */
#define  STESPEC_Next                    5       /* callback function: STEAccNext */
#define  STESPEC_Save                    6       /* callback function: SaveSTEAcc */
#define  STESPEC_Print                   7       /* callback function: Print */
#define  STESPEC_AccSTESpec              8       /* callback function: AccSTESpec */
#define  STESPEC_MAX                     9
#define  STESPEC_ACCTIME                 10
#define  STESPEC_MODE                    11
#define  STESPEC_MIN                     12
#define  STESPEC_SingleDet               13
#define  STESPEC_Log                     14
#define  STESPEC_AutoScale               15
#define  STESPEC_UTCEnd                  16
#define  STESPEC_UTCStart                17
#define  STESPEC_RATES                   18

#define  SWEAFHKP                        19      /* callback function: GenericPanel */
#define  SWEAFHKP_GRAPH                  2
#define  SWEAFHKP_PacketNum              3       /* callback function: PacketNum */
#define  SWEAFHKP_Source                 4
#define  SWEAFHKP_ZoomOut                5       /* callback function: ZoomOut */
#define  SWEAFHKP_MoveDown               6       /* callback function: MoveDown */
#define  SWEAFHKP_MoveUp                 7       /* callback function: MoveUp */
#define  SWEAFHKP_Auto                   8       /* callback function: Auto */
#define  SWEAFHKP_ZoomIn                 9       /* callback function: ZoomIn */

#define  SWEARATES                       20      /* callback function: GenericPanel */
#define  SWEARATES_GRAPH                 2
#define  SWEARATES_Print                 3       /* callback function: Print */
#define  SWEARATES_PlotSWEARates         4       /* callback function: PlotSWEARates */
#define  SWEARATES_MAX                   5
#define  SWEARATES_MIN                   6
#define  SWEARATES_Log                   7
#define  SWEARATES_AutoScale             8
#define  SWEARATES_E15                   9
#define  SWEARATES_E14                   10
#define  SWEARATES_E13                   11
#define  SWEARATES_E12                   12
#define  SWEARATES_E11                   13
#define  SWEARATES_E10                   14
#define  SWEARATES_E9                    15
#define  SWEARATES_E8                    16
#define  SWEARATES_E7                    17
#define  SWEARATES_E6                    18
#define  SWEARATES_D5                    19
#define  SWEARATES_D4                    20
#define  SWEARATES_D3                    21
#define  SWEARATES_D2                    22
#define  SWEARATES_D1                    23
#define  SWEARATES_D0                    24
#define  SWEARATES_E5                    25
#define  SWEARATES_E4                    26
#define  SWEARATES_E3                    27
#define  SWEARATES_E2                    28
#define  SWEARATES_E1                    29
#define  SWEARATES_E0                    30
#define  SWEARATES_DET15                 31
#define  SWEARATES_DET14                 32
#define  SWEARATES_DET13                 33
#define  SWEARATES_DET12                 34
#define  SWEARATES_DET11                 35
#define  SWEARATES_DET10                 36
#define  SWEARATES_DET9                  37
#define  SWEARATES_DET8                  38
#define  SWEARATES_DET7                  39
#define  SWEARATES_DET6                  40
#define  SWEARATES_DET5                  41
#define  SWEARATES_DET4                  42
#define  SWEARATES_DET3                  43
#define  SWEARATES_DET2                  44
#define  SWEARATES_DET1                  45
#define  SWEARATES_DET0                  46
#define  SWEARATES_TEXTMSG               47
#define  SWEARATES_TEXTMSG_2             48
#define  SWEARATES_TEXTMSG_3             49

#define  TIMING                          21      /* callback function: GenericPanel */
#define  TIMING_APID                     2
#define  TIMING_START                    3       /* callback function: StartTiming */
#define  TIMING_GRAPH                    4
#define  TIMING_TIME16                   5
#define  TIMING_PACKETS                  6


     /* Menu Bars, Menus, and Menu Items: */

          /* (no menu bars in the resource file) */


     /* Callback Prototypes: */ 

int  CVICALLBACK AccSTESpec(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK Auto(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK BackHKP(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK BackPacket(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK DisplayHKP(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK DisplayPackets(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK DisplayTiming(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK FindNext(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK FindNextHKP(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK GenericPanel(int panel, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK HideSTEFit(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK MAGIFCFit(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK MoveDown(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK MoveUp(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK NextHKP(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK NextPacket(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK PacketNum(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK Panel(int panel, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK PlotBurst(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK PlotBurstActive(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK PlotBurstCriteria(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK PlotHKP(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK PlotMAG(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK PlotMagPacket(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK PlotPkt(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK PlotSEPHKP(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK PlotSTERates(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK PlotSWEAFHKP(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK PlotSWEARates(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK Print(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SaveHKP(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SaveMag(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SaveSTEAcc(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ScanApIDs(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ScanBurst(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ScanBurstSelect(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ScanHKP(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SelectFile(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK StartTiming(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK STEAccNext(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK STEFit(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK STEFitP(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ZoomIn(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ZoomOut(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);


#ifdef __cplusplus
    }
#endif
