// STEREO IMPACT Decom program
//  Packet Counter module

#include <stdio.h>
#include <userint.h>
#include <ansi_c.h>
#include "DECOM.h"

extern int PlotPktPanel, MainPanel;
int SwapWord(unsigned char *Data, int X); 
void SwapTelemetryBytes(char *Data);
int GetByte(int i);
unsigned int GetWord(int i);
long GetLong3412(int i);
long GetLong4321(int i);
unsigned int GetWord21(int i);

char *GetTime1(unsigned int UTCs, char *dtime);
char *GetTime2(unsigned int UTCs, char *dtime);
char *GetTimeX(unsigned int UTCs, char *dtime);
unsigned long GetUTC(char *time);
int GetData(void);
int GetApID(void);

static int PktCount[10][3000];
static unsigned long UTC[3000];
static int NS;

static int Sel[10] = {
		PLOTPKT_Select0, PLOTPKT_Select1, PLOTPKT_Select2, PLOTPKT_Select3, PLOTPKT_Select4,
		PLOTPKT_Select5, PLOTPKT_Select6, PLOTPKT_Select7, PLOTPKT_Select8, PLOTPKT_Select9 };
static int SelR[10] = {
		PLOTPKT_Select0R, PLOTPKT_Select1R, PLOTPKT_Select2R, PLOTPKT_Select3R, PLOTPKT_Select4R,
		PLOTPKT_Select5R, PLOTPKT_Select6R, PLOTPKT_Select7R, PLOTPKT_Select8R, PLOTPKT_Select9R };

int CVICALLBACK PlotPkt (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	extern char FileName[];
	extern unsigned char Data[];
	int i, j, Dat, AS, ApID1, ApSel[10], ApSelR[10], minute, GRT;
	unsigned long UTC0, UTC1, UTCMax;
	int Min, Max;
	char Str[50];
	static int Colors[10] = {
		VAL_BLACK, 0x803000, VAL_RED, 0xFF8000L, VAL_YELLOW,
		VAL_GREEN, VAL_BLUE, VAL_DK_MAGENTA, VAL_GRAY, VAL_WHITE};

	switch (event) {
		case EVENT_COMMIT:
			DisplayPanel ( PlotPktPanel );
			DeleteGraphPlot (PlotPktPanel, PLOTPKT_GRAPH, -1,
                 VAL_IMMEDIATE_DRAW);
            ClearAxisItems (PlotPktPanel, PLOTPKT_GRAPH, VAL_XAXIS );
			for(i=0; i<10; i++) {
				GetCtrlVal(PlotPktPanel, Sel[i], &ApSel[i]);
				GetCtrlVal(PlotPktPanel, SelR[i], &ApSelR[i]);
			}
			GetCtrlVal(PlotPktPanel, PLOTPKT_Timebase, &GRT); 
			
			GetData();
			GetCtrlVal(MainPanel, DECOM_UTCStart, Str);
			if(GRT) UTC0 = GetWord21(7)*86400+GetLong4321(9)/1000;
			else UTC0 = GetUTC(Str);
			for(i=0; i<10; i++) for(minute=0; minute<3000; minute++) PktCount[i][minute]=0;
			for(i=0; i<3000; i++) UTC[i]=UTC0+60*i;
			NS = 0;
			
			SetWaitCursor(1);

			while(GetData()) {
				SwapTelemetryBytes(Data);
				ApID1 = GetApID();
				for(i=0; i<10; i++) if((ApID1 >= ApSel[i]) && (ApID1 < (ApSel[i]+ApSelR[i]))) {
					if(GRT) UTC1 = GetWord21(7)*86400+GetLong4321(9)/1000;
					else UTC1 = GetLong3412(32);
					minute = (UTC1-UTC0)/60;
					if(minute < 0) minute = 0;
					if(minute > 2999) minute = 2999;
//					UTC[minute] = UTC1;
					PktCount[i][minute]++;
					if(minute > NS) NS = minute;
					if(UTC1 > UTCMax) UTCMax = UTC1;
				}
			}

			GetCtrlVal(PlotPktPanel, PLOTPKT_AutoScale, &AS);
			if(AS) {
				Min = 100000;
				Max = 0;
				for(i=0; i<10; i++) {
					for(j=0; j<NS; j++) {
						if (PktCount[i][j] < Min) Min = PktCount[i][j];
						if (PktCount[i][j] > Max) Max = PktCount[i][j];
					}
				}
				SetCtrlVal(PlotPktPanel, PLOTPKT_MIN, Min);
				SetCtrlVal(PlotPktPanel, PLOTPKT_MAX, Max);
			}
			else {
				GetCtrlVal(PlotPktPanel, PLOTPKT_MIN, &Min);
				GetCtrlVal(PlotPktPanel, PLOTPKT_MAX, &Max);
			}
			
			SetAxisScalingMode (PlotPktPanel, PLOTPKT_GRAPH,
                    VAL_LEFT_YAXIS, VAL_MANUAL, Min, Max);
			SetAxisScalingMode (PlotPktPanel, PLOTPKT_GRAPH,
                    VAL_XAXIS, VAL_MANUAL, UTC0, UTCMax);
                    
                    
			for(i=0; i<10; i++) {
				if(ApSel[i] != 0) {
					PlotXY (PlotPktPanel, PLOTPKT_GRAPH, UTC, PktCount[i], NS+1,
        				VAL_UNSIGNED_INTEGER, VAL_UNSIGNED_INTEGER, VAL_FAT_LINE, VAL_NO_POINT,
        				VAL_SOLID, 1, Colors[i]);
				}
			}
			InsertAxisItem (PlotPktPanel, PLOTPKT_GRAPH, VAL_XAXIS, -1,
				GetTime1(UTC0, Str), (double)UTC0);
			InsertAxisItem (PlotPktPanel, PLOTPKT_GRAPH, VAL_XAXIS, -1,
				GetTime1(UTCMax, Str), (double)(UTCMax-10));
			
			SetWaitCursor(0);
			break;
		}

	return 0;
}
