// SOH decomutator / display
//   Uses decoded version of CTM database

#include <stdio.h>
#include <userint.h>
#include <ansi_c.h>
#include "DECOM.h"

extern int PlotHKPPanel, PlotSEPHKPPanel;
int SwapWord(unsigned char *Data, int X); 
void SwapTelemetryBytes(char *Data);
int GetByte(int i);
unsigned int GetWord(int i);
long GetLong3412(int i);
long GetLong4321(int i);
char *GetTime1(unsigned int UTCs, char *dtime);
char *GetTime2(unsigned int UTCs, char *dtime);
char *GetTimeX(unsigned int UTCs, char *dtime);
int GetData(void);


struct Database {
	char ID[30];
	int Length;
	int Offset;
	char Type[10];
	int Width;
	double A1;
	double A0;
	char Units[10];
	double RL;
	double YL;
	double YH;
	double RH;
	char Convert;
} Database[300], SEPDatabase[300];
int NDB, NDBSEP, NDBSTEUDoor, NDBSTEDDoor;

double YSIc[6];
double MAGc[6], RTDc[3];
double STECurc[6];
int ISWEASTED12V, ISWEASTEDVCC1, ISWEASTED5VD;
int ISTEU12V, ISTEUVCC1, ISTEU5VD;

void init_database()
{
	FILE *File;
	int NS, i;
	char Buffer[1000], *Str, *Next, ID[16];
	struct Database *DB;
	char *GetNextStr(char *Str);
	
	if((File = fopen("database/IMPACT_TLM.txt", "r")) == NULL) {
		MessagePopup ("ERROR",
			"Cannot open telemetry database file IMPACT_TLM.txt");
		return;
	}
	for(NS=0; NS<6; NS++) fgets (Buffer, sizeof(Buffer), File);
	NDB = 0;
	InsertListItem (PlotHKPPanel, PLOTHKP_Select0, -1, "-NULL-", -1);			
	InsertListItem (PlotHKPPanel, PLOTHKP_Select1, -1, "-NULL-", -1);			
	InsertListItem (PlotHKPPanel, PLOTHKP_Select2, -1, "-NULL-", -1);			
	InsertListItem (PlotHKPPanel, PLOTHKP_Select3, -1, "-NULL-", -1);			
	InsertListItem (PlotHKPPanel, PLOTHKP_Select4, -1, "-NULL-", -1);			
	InsertListItem (PlotHKPPanel, PLOTHKP_Select5, -1, "-NULL-", -1);			
	InsertListItem (PlotHKPPanel, PLOTHKP_Select6, -1, "-NULL-", -1);			
	InsertListItem (PlotHKPPanel, PLOTHKP_Select7, -1, "-NULL-", -1);			
	InsertListItem (PlotHKPPanel, PLOTHKP_Select8, -1, "-NULL-", -1);			
	InsertListItem (PlotHKPPanel, PLOTHKP_Select9, -1, "-NULL-", -1);			
	while(!feof(File) && memcmp(Buffer, "Checksum", 8)) {
		DB = &Database[NDB];
		Next = GetNextStr(Buffer);
		strcpy(DB->ID, Buffer);
		if(!strcmp(DB->ID, "ISWEASTE12V")) ISWEASTED12V = NDB;
		else if(!strcmp(DB->ID, "ISWEASTEDVCC1")) ISWEASTEDVCC1 = NDB; 
		else if(!strcmp(DB->ID, "ISWEASTED5VD")) ISWEASTED5VD = NDB; 
		else if(!strcmp(DB->ID, "ISTEU12V")) ISTEU12V = NDB;
		else if(!strcmp(DB->ID, "ISTEUVCC1")) ISTEUVCC1 = NDB; 
		else if(!strcmp(DB->ID, "ISTEU5VD")) ISTEU5VD = NDB; 
		Next = GetNextStr(Str=Next);
		DB->Length = atoi(Str);
		Next = GetNextStr(Str=Next);
		DB->Offset = atoi(Str);
		Next = GetNextStr(Str=Next);
		strncpy(DB->Type, Str, 10);
		Next = GetNextStr(Str=Next);
		DB->Width = atoi(Str);
		Next = GetNextStr(Str=Next);
		DB->A1 = 1.0;
		if(!strcmp(Str, "LOGT")) DB->Convert = 'L';
		else if(!strcmp(Str, "MAG")) DB->Convert = 'M';
		else if(!strcmp(Str, "RTD")) DB->Convert = 'R';
		else if(!strcmp(Str, "YSI")) DB->Convert = 'Y';
		else {
			DB->A1 = atof(Str);
			if(DB->A1 == 0.) DB->A1 = 1.0;
			if(!strcmp(DB->ID, "ISTEUCur")) DB->Convert = 'U';
			else if(!strcmp(DB->ID, "ISWEASTEDCur")) DB->Convert = 'D';
			else DB->Convert = 0;
		}
		Next = GetNextStr(Str=Next);
		DB->A0 = atof(Str);
		Next = GetNextStr(Str=Next);
		strncpy(DB->Units, Str, 10);
		Next = GetNextStr(Str=Next);
		DB->RL = atof(Str);
		Next = GetNextStr(Str=Next);
		DB->YL = atof(Str);
		Next = GetNextStr(Str=Next);
		DB->YH = atof(Str);
		Next = GetNextStr(Str=Next);
		DB->RH = atof(Str);
		if((DB->ID[0] != '#') && (DB->ID[0] != 0)) {
			InsertListItem (PlotHKPPanel, PLOTHKP_Select0, -1, DB->ID, NDB);			
			InsertListItem (PlotHKPPanel, PLOTHKP_Select1, -1, DB->ID, NDB);
			InsertListItem (PlotHKPPanel, PLOTHKP_Select2, -1, DB->ID, NDB);			
			InsertListItem (PlotHKPPanel, PLOTHKP_Select3, -1, DB->ID, NDB);			
			InsertListItem (PlotHKPPanel, PLOTHKP_Select4, -1, DB->ID, NDB);
			InsertListItem (PlotHKPPanel, PLOTHKP_Select5, -1, DB->ID, NDB);			
			InsertListItem (PlotHKPPanel, PLOTHKP_Select6, -1, DB->ID, NDB);			
			InsertListItem (PlotHKPPanel, PLOTHKP_Select7, -1, DB->ID, NDB);			
			InsertListItem (PlotHKPPanel, PLOTHKP_Select8, -1, DB->ID, NDB);
			InsertListItem (PlotHKPPanel, PLOTHKP_Select9, -1, DB->ID, NDB);
			NDB++;
		}
// Add in door position status
		if(!memcmp(DB->ID,"ISTEUDig", 8)) {
			Database[NDB]= Database[NDB-1];
			InsertListItem (PlotHKPPanel, PLOTHKP_Select0, -1, "STEUDoor", NDB);			
			InsertListItem (PlotHKPPanel, PLOTHKP_Select1, -1, "STEUDoor", NDB);
			InsertListItem (PlotHKPPanel, PLOTHKP_Select2, -1, "STEUDoor", NDB);			
			InsertListItem (PlotHKPPanel, PLOTHKP_Select3, -1, "STEUDoor", NDB);			
			InsertListItem (PlotHKPPanel, PLOTHKP_Select4, -1, "STEUDoor", NDB);
			InsertListItem (PlotHKPPanel, PLOTHKP_Select5, -1, "STEUDoor", NDB);			
			InsertListItem (PlotHKPPanel, PLOTHKP_Select6, -1, "STEUDoor", NDB);			
			InsertListItem (PlotHKPPanel, PLOTHKP_Select7, -1, "STEUDoor", NDB);			
			InsertListItem (PlotHKPPanel, PLOTHKP_Select8, -1, "STEUDoor", NDB);
			InsertListItem (PlotHKPPanel, PLOTHKP_Select9, -1, "STEUDoor", NDB);
			NDBSTEUDoor = NDB++;
		}
		if(!memcmp(DB->ID,"ISWEASTEDDig", 12)) {
			Database[NDB]= Database[NDB-1];
			InsertListItem (PlotHKPPanel, PLOTHKP_Select0, -1, "STEDDoor", NDB);			
			InsertListItem (PlotHKPPanel, PLOTHKP_Select1, -1, "STEDDoor", NDB);
			InsertListItem (PlotHKPPanel, PLOTHKP_Select2, -1, "STEDDoor", NDB);			
			InsertListItem (PlotHKPPanel, PLOTHKP_Select3, -1, "STEDDoor", NDB);			
			InsertListItem (PlotHKPPanel, PLOTHKP_Select4, -1, "STEDDoor", NDB);
			InsertListItem (PlotHKPPanel, PLOTHKP_Select5, -1, "STEDDoor", NDB);			
			InsertListItem (PlotHKPPanel, PLOTHKP_Select6, -1, "STEDDoor", NDB);			
			InsertListItem (PlotHKPPanel, PLOTHKP_Select7, -1, "STEDDoor", NDB);			
			InsertListItem (PlotHKPPanel, PLOTHKP_Select8, -1, "STEDDoor", NDB);
			InsertListItem (PlotHKPPanel, PLOTHKP_Select9, -1, "STEDDoor", NDB);
			NDBSTEDDoor = NDB++;
		}
		fgets (Buffer, sizeof(Buffer), File);
	}
// Now find non-linear conversions
	while(!feof(File)) {
		if(!memcmp(Buffer, "YSI", 3)) {
			for(i=0; i<6; i++) {
				fgets (Buffer, sizeof(Buffer), File);
				sscanf(Buffer, "%1s %lf", ID, &YSIc[i]);
			}
		}
		if(!memcmp(Buffer, "RTD", 3)) {
			for(i=0; i<3; i++) {
				fgets (Buffer, sizeof(Buffer), File);
				sscanf(Buffer, "%1s %lf", ID, &RTDc[i]);
			}
		}
		if(!memcmp(Buffer, "MAG", 3)) {
			for(i=0; i<6; i++) {
				fgets (Buffer, sizeof(Buffer), File);
				sscanf(Buffer, "%1s %lf", ID, &MAGc[i]);
			}
		}
		if(!memcmp(Buffer, "ISWEASTEDCur and ISTEUCur conversions", 37)) {
			fgets (Buffer, sizeof(Buffer), File);
			fgets (Buffer, sizeof(Buffer), File);
			fgets (Buffer, sizeof(Buffer), File);
			for(i=0; i<6; i++) {
				fgets (Buffer, sizeof(Buffer), File);
				sscanf(Buffer, "%5s %lf", ID, &STECurc[i]);
			}
		}
		fgets (Buffer, sizeof(Buffer), File);
	}
	fclose(File);
	
// Now do SEP housekeeping
	if((File = fopen("database/sep_hkg.txt", "r")) == NULL) {
		MessagePopup ("ERROR",
			"Cannot open telemetry database file SEP_HKG.txt");
		return;
	}
	InsertListItem (PlotSEPHKPPanel, PLOTSEPHKP_Select0, -1, "-NULL-", -1);			
	InsertListItem (PlotSEPHKPPanel, PLOTSEPHKP_Select1, -1, "-NULL-", -1);			
	InsertListItem (PlotSEPHKPPanel, PLOTSEPHKP_Select2, -1, "-NULL-", -1);			
	InsertListItem (PlotSEPHKPPanel, PLOTSEPHKP_Select3, -1, "-NULL-", -1);			
	InsertListItem (PlotSEPHKPPanel, PLOTSEPHKP_Select4, -1, "-NULL-", -1);			
	InsertListItem (PlotSEPHKPPanel, PLOTSEPHKP_Select5, -1, "-NULL-", -1);			
	InsertListItem (PlotSEPHKPPanel, PLOTSEPHKP_Select6, -1, "-NULL-", -1);			
	InsertListItem (PlotSEPHKPPanel, PLOTSEPHKP_Select7, -1, "-NULL-", -1);			
	InsertListItem (PlotSEPHKPPanel, PLOTSEPHKP_Select8, -1, "-NULL-", -1);			
	InsertListItem (PlotSEPHKPPanel, PLOTSEPHKP_Select9, -1, "-NULL-", -1);			
	for(NS=0; NS<6; NS++) fgets (Buffer, sizeof(Buffer), File);
	NDB=0;
	while(!feof(File) && memcmp(Buffer, "Checksum", 8)) {
		DB = &SEPDatabase[NDB];
		Next = GetNextStr(Buffer);
		strcpy(DB->ID, Buffer);
		Next = GetNextStr(Str=Next);
		DB->Length = atoi(Str);
		Next = GetNextStr(Str=Next);
		DB->Offset = atoi(Str);
		Next = GetNextStr(Str=Next);
		strcpy(DB->Type, Str);
		Next = GetNextStr(Str=Next);
		DB->Width = atoi(Str);
		Next = GetNextStr(Str=Next);
		DB->A1 = 1.0;
		DB->A1 = atof(Str);
		if(DB->A1 == 0.) DB->A1 = 1.0;
		Next = GetNextStr(Str=Next);
		DB->A0 = atof(Str);
		DB->Convert = 1;
		Next = GetNextStr(Str=Next);
		Str[9] = 0;
		strcpy(DB->Units, Str);
		Next = GetNextStr(Str=Next);
		DB->RL = atof(Str);
		Next = GetNextStr(Str=Next);
		DB->YL = atof(Str);
		Next = GetNextStr(Str=Next);
		DB->YH = atof(Str);
		Next = GetNextStr(Str=Next);
		DB->RH = atof(Str);
		if((DB->ID[0] != '#') && (DB->ID[0] != 0)) {
			InsertListItem (PlotSEPHKPPanel, PLOTSEPHKP_Select0, -1, DB->ID, NDB);			
			InsertListItem (PlotSEPHKPPanel, PLOTSEPHKP_Select1, -1, DB->ID, NDB);
			InsertListItem (PlotSEPHKPPanel, PLOTSEPHKP_Select2, -1, DB->ID, NDB);			
			InsertListItem (PlotSEPHKPPanel, PLOTSEPHKP_Select3, -1, DB->ID, NDB);			
			InsertListItem (PlotSEPHKPPanel, PLOTSEPHKP_Select4, -1, DB->ID, NDB);
			InsertListItem (PlotSEPHKPPanel, PLOTSEPHKP_Select5, -1, DB->ID, NDB);			
			InsertListItem (PlotSEPHKPPanel, PLOTSEPHKP_Select6, -1, DB->ID, NDB);			
			InsertListItem (PlotSEPHKPPanel, PLOTSEPHKP_Select7, -1, DB->ID, NDB);			
			InsertListItem (PlotSEPHKPPanel, PLOTSEPHKP_Select8, -1, DB->ID, NDB);
			InsertListItem (PlotSEPHKPPanel, PLOTSEPHKP_Select9, -1, DB->ID, NDB);
			NDB++;
		}
		fgets (Buffer, sizeof(Buffer), File);
	}

}


char *GetNextStr(char *Str)
{
	char *Next;
	
	Next = Str;
	while((*Next != '\t') && (*Next != 0) && (*Next != '\n')) Next++;
	if(*Next == 0) return Next;
	*Next = 0;
	return Next+1;
}

#define SIZE 1000000
float Samples[24][SIZE];
long UTC[SIZE];
static int NS;
static int Sel[10] = {
		PLOTHKP_Select0, PLOTHKP_Select1, PLOTHKP_Select2, PLOTHKP_Select3, PLOTHKP_Select4,
		PLOTHKP_Select5, PLOTHKP_Select6, PLOTHKP_Select7, PLOTHKP_Select8, PLOTHKP_Select9 };

int CVICALLBACK PlotHKP (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	extern char FileName[];
	extern unsigned char Data[];
	int Select, i, j, Dat, AS, Log;
	float Val;
	double Min, Max;
	double V, V12V, V5VD, VVCC1;
	char Str[50];
	static int Colors[10] = {
		VAL_BLACK, 0x803000, VAL_RED, 0xFF8000L, VAL_YELLOW,
		VAL_GREEN, VAL_BLUE, VAL_DK_MAGENTA, VAL_GRAY, VAL_WHITE};

	switch (event) {
		case EVENT_COMMIT:
			DisplayPanel ( PlotHKPPanel );
			DeleteGraphPlot (PlotHKPPanel, PLOTHKP_GRAPH, -1,
                 VAL_IMMEDIATE_DRAW);
            ClearAxisItems (PlotHKPPanel, PLOTHKP_GRAPH, VAL_XAXIS );
			for(NS=i=0; i<10; i++) {
				GetCtrlVal(PlotHKPPanel, Sel[i], &Select);
				if(Select != -1) NS++;
			}
			if(NS == 0) break;
			SetWaitCursor(1);
			NS=0;
			while(GetData() && (NS<SIZE)) if((SwapWord(Data, 0)&0x7FF) == 0x200) {
				SwapTelemetryBytes(Data);
				UTC[NS] = GetLong3412(32);
				for(i=0; i<10; i++) {
					GetCtrlVal(PlotHKPPanel, Sel[i], &Select);
					if(Select != -1) {
						if(Database[Select].Length == 1) Dat = GetByte(26+Database[Select].Offset);
						else Dat = GetWord(26+Database[Select].Offset);
						if((Select == NDBSTEUDoor) || (Select == NDBSTEDDoor)) {
							Samples[i][NS]= (Dat>>4)&3;
						}
						else switch(Database[Select].Convert) {
							case 0 :
							case 1 :
								Samples[i][NS] = Dat*Database[Select].A1 + Database[Select].A0;
								break;
							case 'Y' :
								Samples[i][NS] = YSIc[0]+Dat*(YSIc[1]+Dat*(YSIc[2]+Dat*(YSIc[3]+Dat*(YSIc[4] + Dat*YSIc[5]))));
								break;
							case 'M' :
								Samples[i][NS] = MAGc[0]+Dat*(MAGc[1]+Dat*(MAGc[2]+Dat*(MAGc[3]+Dat*(MAGc[4] + Dat*MAGc[5]))));
								break;
							case 'R' :
								Samples[i][NS] = RTDc[0]+Dat*(RTDc[1]+Dat*RTDc[2]);
								break;
							case 'L' :
								Samples[i][NS] = ((Dat < 32)? Dat: (16+(Dat&0xf))<<(Dat/16 -1))/65536.;
								break;
							case 'D' :		// ISWEASTEDCur
								V12V = GetWord(26+Database[ISWEASTED12V].Offset)*Database[ISWEASTED12V].A1 + Database[ISWEASTED12V].A0;
								VVCC1 = GetWord(26+Database[ISWEASTEDVCC1].Offset)*Database[ISWEASTEDVCC1].A1 + Database[ISWEASTEDVCC1].A0;
								V5VD = GetWord(26+Database[ISWEASTED5VD].Offset)*Database[ISWEASTED5VD].A1 + Database[ISWEASTED5VD].A0;
								V =  Dat*Database[Select].A1 + Database[Select].A0;
								Samples[i][NS] = STECurc[3]*V + STECurc[4]*V12V - STECurc[5]*(VVCC1-V5VD);
								break;
							case 'U' :		// ISTEUCur
								V12V = GetWord(26+Database[ISTEU12V].Offset)*Database[ISTEU12V].A1 + Database[ISTEU12V].A0;
								VVCC1 = GetWord(26+Database[ISTEUVCC1].Offset)*Database[ISTEUVCC1].A1 + Database[ISTEUVCC1].A0;
								V5VD = GetWord(26+Database[ISTEU5VD].Offset)*Database[ISTEU5VD].A1 + Database[ISTEU5VD].A0;
								V =  Dat*Database[Select].A1 + Database[Select].A0;
								Samples[i][NS] = STECurc[0]*V + STECurc[1]*V12V - STECurc[2]*(VVCC1-V5VD);
								break;
							default :
								Samples[i][NS] = 0.;
						}
					}
				}
				NS++;
			}

			GetCtrlVal(PlotHKPPanel, PLOTHKP_AutoScale, &AS);
			GetCtrlVal(PlotHKPPanel, PLOTHKP_Log, &Log);
			if(AS) {
				Min = 1.E6;
				Max = -1.E6;
				for(i=0; i<10; i++) {
					GetCtrlVal(PlotHKPPanel, Sel[i], &Select);
					if(Select != -1) {
						for(j=0; j<NS; j++) {
							if (Samples[i][j] < Min) Min = Samples[i][j];
							if (Samples[i][j] > Max) Max = Samples[i][j];
						}
					}
				}
				SetCtrlVal(PlotHKPPanel, PLOTHKP_MIN, Min);
				SetCtrlVal(PlotHKPPanel, PLOTHKP_MAX, Max);
			}
			else {
				GetCtrlVal(PlotHKPPanel, PLOTHKP_MIN, &Min);
				GetCtrlVal(PlotHKPPanel, PLOTHKP_MAX, &Max);
			}
			
			if(Log && (Min < 1.e-10)) Min = 1.e-10;
			
			SetCtrlAttribute (PlotHKPPanel, PLOTHKP_GRAPH,
				ATTR_YMAP_MODE, Log?VAL_LOG:VAL_LINEAR);			
			SetAxisScalingMode (PlotHKPPanel, PLOTHKP_GRAPH,
                    VAL_LEFT_YAXIS, VAL_MANUAL, Min, Max);
                    
			for(i=0; i<10; i++) {
				GetCtrlVal(PlotHKPPanel, Sel[i], &Select);
				if(Select != -1) {
					PlotXY (PlotHKPPanel, PLOTHKP_GRAPH, UTC, Samples[i], NS,
        				VAL_UNSIGNED_INTEGER, VAL_FLOAT, VAL_FAT_LINE, VAL_NO_POINT,
        				VAL_SOLID, 1, Colors[i]);
				}
			}
			InsertAxisItem (PlotHKPPanel, PLOTHKP_GRAPH, VAL_XAXIS, -1,
				GetTime1(UTC[0], Str), UTC[0]);
			InsertAxisItem (PlotHKPPanel, PLOTHKP_GRAPH, VAL_XAXIS, -1,
				GetTime1(UTC[NS-1], Str), UTC[NS-1]);
			
			SetWaitCursor(0);
			break;
		}

	return 0;
}

int CVICALLBACK SaveHKP (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	FILE *File;
	extern char FileName[];
	char OutName[100];
	int i, j, Skip, Select[10];
	unsigned int MaxFileSize, MaxTimeRes;
	long UTCLast;
	char Str[50];
	
	
	switch (event) {
		case EVENT_COMMIT:
			if(NS < 1) return 0;
			GetCtrlVal(PlotHKPPanel, PLOTHKP_MaxFileSize, &MaxFileSize);
			GetCtrlVal(PlotHKPPanel, PLOTHKP_MaxTimeRes, &MaxTimeRes);
			for(Skip=1; NS/Skip > MaxFileSize; Skip++);
			strcpy(OutName, FileName);
			strcpy(strrchr(OutName, '.'), ".txt");
			File = fopen(OutName, "w");
			fprintf(File, "STEREO IMPACT Housekeeping Data\n");
			fprintf(File, " Data extracted from telemetry file %s\n\n", FileName);
			fprintf(File, "Time,UTC ");
			for(i=0; i<10; i++) {
				GetCtrlVal(PlotHKPPanel, Sel[i], &Select[i]);
				if(Select[i] != -1)
					fprintf(File, "\t%s ", Database[Select[i]].ID);
			}
			fprintf(File, "\n");
			UTCLast = 0;
			for(j=0; j<NS; j+=Skip) {
				if((UTC[j]-UTCLast) >= MaxTimeRes) {
					UTCLast = UTC[j];
					GetTimeX(UTC[j], Str);
					fprintf(File, "%20s ", Str); 
					for(i=0; i<10; i++)
						if(Select[i] != -1) fprintf(File, "\t%f ", Samples[i][j]);
					fprintf(File, "\n");
				}
			}
			fclose(File);
	}
			
	return 0;
}

int CVICALLBACK PlotSEPHKP (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	extern char FileName[];
	extern unsigned char Data[];
	int Select, i, j, Dat, AS;
	float Val;
	double Min, Max;
	char Str[50];
	static int Colors[10] = {
		VAL_BLACK, 0x803000, VAL_RED, 0xFF8000L, VAL_YELLOW,
		VAL_GREEN, VAL_BLUE, VAL_DK_MAGENTA, VAL_GRAY, VAL_WHITE};

	switch (event) {
		case EVENT_COMMIT:
			DisplayPanel ( PlotSEPHKPPanel );
			DeleteGraphPlot (PlotSEPHKPPanel, PLOTSEPHKP_GRAPH, -1,
                 VAL_IMMEDIATE_DRAW);
            ClearAxisItems (PlotSEPHKPPanel, PLOTSEPHKP_GRAPH, VAL_XAXIS );
			for(NS=i=0; i<10; i++) {
				GetCtrlVal(PlotSEPHKPPanel, Sel[i], &Select);
				if(Select != -1) NS++;
			}
			if(NS == 0) break;
			SetWaitCursor(1);
			NS=0;
			while(GetData() && (NS<SIZE)) if((SwapWord(Data, 0)&0x7FF) == 0x241) {
//				SwapTelemetryBytes(Data);
				UTC[NS] = GetLong4321(32);
				for(i=0; i<10; i++) {
					GetCtrlVal(PlotSEPHKPPanel, Sel[i], &Select);
					if(Select != -1) {
						if(Database[Select].Length == 1) Dat = GetByte(26+Database[Select].Offset);
						else Dat = GetWord(26+Database[Select].Offset);
						switch(Database[Select].Convert) {
							case 0 :
							case 1 :
								Samples[i][NS] = Dat*Database[Select].A1 + Database[Select].A0;
								break;
							case 'Y' :
								Samples[i][NS] = YSIc[0]+Dat*(YSIc[1]+Dat*(YSIc[2]+Dat*(YSIc[3]+Dat*(YSIc[4] + Dat*YSIc[5]))));
								break;
							case 'M' :
								Samples[i][NS] = MAGc[0]+Dat*(MAGc[1]+Dat*(MAGc[2]+Dat*(MAGc[3]+Dat*(MAGc[4] + Dat*MAGc[5]))));
								break;
							case 'R' :
								Samples[i][NS] = RTDc[0]+Dat*(RTDc[1]+Dat*RTDc[2]);
								break;
							case 'L' :
								Samples[i][NS] = ((Dat < 32)? Dat: (16+(Dat&0xf))<<(Dat/16 -1))/65536.;
								break;
							default :
								Samples[i][NS] = 0.;
						}
					}
				}
				NS++;
			}

			GetCtrlVal(PlotSEPHKPPanel, PLOTSEPHKP_AutoScale, &AS);
			if(AS) {
				Min = 1.E6;
				Max = -1.E6;
				for(i=0; i<10; i++) {
					GetCtrlVal(PlotSEPHKPPanel, Sel[i], &Select);
					if(Select != -1) {
						for(j=0; j<NS; j++) {
							if (Samples[i][j] < Min) Min = Samples[i][j];
							if (Samples[i][j] > Max) Max = Samples[i][j];
						}
					}
				}
				SetCtrlVal(PlotSEPHKPPanel, PLOTSEPHKP_MIN, Min);
				SetCtrlVal(PlotSEPHKPPanel, PLOTSEPHKP_MAX, Max);
			}
			else {
				GetCtrlVal(PlotSEPHKPPanel, PLOTSEPHKP_MIN, &Min);
				GetCtrlVal(PlotSEPHKPPanel, PLOTSEPHKP_MAX, &Max);
			}
			
			SetAxisScalingMode (PlotSEPHKPPanel, PLOTSEPHKP_GRAPH,
                    VAL_LEFT_YAXIS, VAL_MANUAL, Min, Max);
                    
			for(i=0; i<10; i++) {
				GetCtrlVal(PlotSEPHKPPanel, Sel[i], &Select);
				if(Select != -1) {
					PlotXY (PlotSEPHKPPanel, PLOTSEPHKP_GRAPH, UTC, Samples[i], NS,
        				VAL_UNSIGNED_INTEGER, VAL_FLOAT, VAL_FAT_LINE, VAL_NO_POINT,
        				VAL_SOLID, 1, Colors[i]);
				}
			}
			InsertAxisItem (PlotSEPHKPPanel, PLOTSEPHKP_GRAPH, VAL_XAXIS, -1,
				GetTime1(UTC[0], Str), UTC[0]);
			InsertAxisItem (PlotSEPHKPPanel, PLOTSEPHKP_GRAPH, VAL_XAXIS, -1,
				GetTime1(UTC[NS-1], Str), UTC[NS-1]);
			
			SetWaitCursor(0);
			break;
		}

	return 0;
}


